### Class

# CM Matrix

#### Description [src]

    final class CM.Matrix : GObject.Object
    {
      /* No available fields */
    }

The main matrix object.

This object needs to be created after calling `cm_init()` and before adding any `CmClient`s. After creating the object you can open the database and load known clients via `cm_matrix_open_async()` and and `cm_matrix_client_new()`.

#### Hierarchy

#### Ancestors

- GObject

#### Constructors

###### cm_matrix_new

Create a new `CmMatrix` with the provided details.

#### Instance methods

###### cm_matrix_add_clients_async

Add clients identified by their secrets.

###### cm_matrix_add_clients_finish

No description available.

###### cm_matrix_client_new

Create a new `CmClient`. It’s an error to create a new client before opening the db with `cm_matrix_open_async()`.

###### cm_matrix_delete_client_async

No description available.

###### cm_matrix_delete_client_finish

No description available.

###### cm_matrix_get_clients_list

Get the list of clients.

###### cm_matrix_has_client_with_id

No description available.

###### cm_matrix_is_ready

No description available.

###### cm_matrix_open_async

Open the matrix db and loads already known clients.

###### cm_matrix_open_finish

No description available.

###### cm_matrix_save_client_async

Save the client to database and keyring.

###### cm_matrix_save_client_finish

Finish call to `cm_matrix_save_client_async()`.

###### cm_matrix_save_client_sync

Save client to database and keyring.

since: 0.0.2

##### Methods inherited from GObject (43)

Please see GObject for a full list of methods.

#### Properties

###### CM.Matrix:ready

Whether matrix is enabled and usable.

#### Signals

##### Signals inherited from GObject (1)

###### GObject::notify

The notify signal is emitted on an object when one of its properties has its value set through g_object_set_property(), g_object_set(), et al.

#### Class structure

    struct CMMatrixClass {
      GObjectClass parent_class;

    }

No description available.

###### Class members

`parent_class: GObjectClass`

  No description available.